#! /bin/bash

trap "echo '*** BUILD FAILED! ***' 1>&2" ERR
set -ex -o pipefail
umask 022
export PATH='/bin:/usr/bin:/usr/local/bin'
export CFLAGS=${CFLAGS:--Os}
export CXXFLAGS=${CXXFLAGS:--Os}

rebuild () {
    tar xjf socat-1.7.2.0.tar.bz2
    cd socat-1.7.2.0
    ./configure --prefix=/usr --sysconfdir=/etc --localstatedir=/var \
	    --disable-readline --disable-openssl
    ed -s config.h >/dev/null <<EOF
/HAVE_LINUX_ERRQUEUE_H/d
i
#define HAVE_LINUX_ERRQUEUE_H 1
.
w
q
EOF
    make
    strip -R .note -R .comment socat
    mkdir -p ../socat/bin
    cp socat ../socat/bin/
    cd ..
    rm -rf socat-1.7.2.0
}

while read FN; do
    eval "[ -e $FN ] || rebuild"
done < MANIFEST

ARCH=`ipkg -V 0 print_architecture | tail -n 1 | cut -f2 -d' '`
for CTRLFILE in */CONTROL/control; do
    sed -i -e "s/__ARCH__/$ARCH/g" $CTRLFILE
    sudo ipkg-build -o root -g root `dirname $CTRLFILE`/..
done
